/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.alibaba.fastjson.JSON
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemValueVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutTotalVO
 *  com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO
 *  com.deepexi.scd.calculate.domain.vo.word.CalculateReportActivityVO
 *  com.deepexi.scd.calculate.domain.vo.word.CalculateReportFactorVO
 *  com.deepexi.scd.calculate.domain.vo.word.PowerNetReportTotalMapVO
 *  com.deepexi.scd.calculate.service.TemplateService
 *  com.deepexi.scd.calculate.util.DataCollectors
 *  com.deepexi.scd.common.enums.business.CalculateItemValueTypeEnum
 *  com.deepexi.scd.common.extensions.ExNumeric
 *  com.deepexi.spa.commons.utils.CollectionUtils
 *  com.deepexi.spa.commons.utils.StringUtils
 *  com.deepoove.poi.config.Configure
 *  org.apache.commons.collections.MapUtils
 *  org.springframework.stereotype.Service
 */
package com.deepexi.scd.calculate.service.impl.report;

import com.alibaba.fastjson.JSON;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemValueVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutTotalVO;
import com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO;
import com.deepexi.scd.calculate.domain.vo.word.CalculateReportActivityVO;
import com.deepexi.scd.calculate.domain.vo.word.CalculateReportFactorVO;
import com.deepexi.scd.calculate.domain.vo.word.PowerNetReportTotalMapVO;
import com.deepexi.scd.calculate.service.TemplateService;
import com.deepexi.scd.calculate.util.DataCollectors;
import com.deepexi.scd.common.enums.business.CalculateItemValueTypeEnum;
import com.deepexi.scd.common.extensions.ExNumeric;
import com.deepexi.spa.commons.utils.CollectionUtils;
import com.deepexi.spa.commons.utils.StringUtils;
import com.deepoove.poi.config.Configure;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.stream.Collectors;
import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang3.time.DateFormatUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

@Service
public class IndustryReport442
implements TemplateService {
    private static final Logger log = LoggerFactory.getLogger(IndustryReport442.class);
    private static final String TEMPLATE_NAME = "industryTemplate442.docx";

    public void exportTemplate(ExportReportLayoutVO exportReportLayoutVO, Map<String, Object> paramMap) throws Exception {
        log.info("exportReportLayoutVO={}", (Object)JSON.toJSONString((Object)exportReportLayoutVO));
        paramMap.put("tplName", TEMPLATE_NAME);
        List totalList = (List)exportReportLayoutVO.getTotalMap().get("TOTAL");
        PowerNetReportTotalMapVO totalMapVO = this.getCalculateReportTotalMapVO(totalList);
        List activityList = (List)exportReportLayoutVO.getTableMap().get("ALL");
        log.info("activityList={}", (Object)JSON.toJSONString((Object)activityList));
        Map<String, List> activityMap = activityList.stream().collect(Collectors.toMap(CalculateReportLayoutObjectVO::getObjectName, CalculateReportLayoutObjectVO::getItemList));
        List sixItemVOList = activityMap.get("六氟化硫回收");
        List lossItemVOList = activityMap.get("输配电损失");
        CalculateReportActivityVO sixActivityVO = this.getSixActivityVO(sixItemVOList);
        CalculateReportActivityVO lossActivityVO = this.getLossActivityVO(lossItemVOList);
        List factorList = (List)exportReportLayoutVO.getTableMap().get("FACTOR");
        log.info("factorList={}", (Object)JSON.toJSONString((Object)factorList));
        Map<String, List> factorMap = factorList.stream().collect(Collectors.toMap(CalculateReportLayoutObjectVO::getObjectName, CalculateReportLayoutObjectVO::getItemList));
        List lossFactorVOList = factorMap.get("输配电损失");
        CalculateReportFactorVO lossFactorVO = this.getLossFactorVO(lossFactorVOList);
        Configure config = Configure.newBuilder().build();
        paramMap.put("enterpriseName", exportReportLayoutVO.getEnterpriseName());
        paramMap.put("totalMap", totalMapVO);
        paramMap.put("sixActivityVO", sixActivityVO);
        paramMap.put("lossActivityVO", lossActivityVO);
        paramMap.put("lossFactorVO", lossFactorVO);
        paramMap.put("reportTime", DateFormatUtils.format(exportReportLayoutVO.getReportTime(), "yyyy年MM月dd日"));
        paramMap.put("config", config);
    }

    public String getTemplateName() {
        return TEMPLATE_NAME;
    }

    private CalculateReportActivityVO getSixActivityVO(List<CalculateLayoutItemVO> sixItemVOList) {
        CalculateReportActivityVO reportActivityVO = new CalculateReportActivityVO();
        if (CollectionUtils.isNotEmpty(sixItemVOList)) {
            Map totalByTableNameMap = DataCollectors.groupingBy(sixItemVOList, CalculateLayoutItemVO::getTableName);
            List repairList = (List)totalByTableNameMap.get("检修设备");
            Map<String, BigDecimal> repairSumMap = this.getSumBigDecimalMap(repairList);
            reportActivityVO.setValue1(ExNumeric.formatValue((BigDecimal)repairSumMap.get("检修设备六氟化硫容量"), (Integer)5));
            reportActivityVO.setValue2(ExNumeric.formatValue((BigDecimal)repairSumMap.get("检修设备六氟化硫实际回收量"), (Integer)5));
            List retireList = (List)totalByTableNameMap.get("退役设备");
            Map<String, BigDecimal> retireSumMap = this.getSumBigDecimalMap(retireList);
            reportActivityVO.setValue3(ExNumeric.formatValue((BigDecimal)retireSumMap.get("退役设备六氟化硫容量"), (Integer)5));
            reportActivityVO.setValue4(ExNumeric.formatValue((BigDecimal)retireSumMap.get("退役设备六氟化硫实际回收量"), (Integer)5));
        }
        return reportActivityVO;
    }

    private CalculateReportActivityVO getLossActivityVO(List<CalculateLayoutItemVO> lossItemVOList) {
        CalculateReportActivityVO reportActivityVO = new CalculateReportActivityVO();
        if (CollectionUtils.isNotEmpty(lossItemVOList)) {
            Map totalByTableNameMap = DataCollectors.groupingBy(lossItemVOList, CalculateLayoutItemVO::getTableName);
            List lossItemList = (List)totalByTableNameMap.get("输配电损失");
            Map<String, BigDecimal> lossSumMap = this.getSumBigDecimalMap(lossItemList);
            BigDecimal onNetEle = lossSumMap.get("电厂上网电量");
            BigDecimal inEle = lossSumMap.get("外省输入电量");
            BigDecimal outEle = lossSumMap.get("外省输出电量");
            reportActivityVO.setValue1(ExNumeric.formatValue((BigDecimal)onNetEle, (Integer)5));
            reportActivityVO.setValue2(ExNumeric.formatValue((BigDecimal)inEle, (Integer)5));
            reportActivityVO.setValue3(ExNumeric.formatValue((BigDecimal)outEle, (Integer)5));
            BigDecimal buyNum = lossSumMap.get("售电量");
            BigDecimal outNum = onNetEle.add(inEle).subtract(outEle).subtract(buyNum);
            reportActivityVO.setValue4(ExNumeric.formatValue((BigDecimal)buyNum, (Integer)5));
            reportActivityVO.setValue5(ExNumeric.formatValue((BigDecimal)outNum, (Integer)5));
        }
        return reportActivityVO;
    }

    private CalculateReportFactorVO getLossFactorVO(List<CalculateLayoutItemVO> lossFactorVOList) {
        CalculateReportFactorVO reportFactorVO = new CalculateReportFactorVO();
        if (CollectionUtils.isNotEmpty(lossFactorVOList)) {
            Map<String, BigDecimal> computeItemValueMap = this.getSumBigDecimalMap(lossFactorVOList);
            BigDecimal dischargeFactorValue = computeItemValueMap.get("排放因子");
            reportFactorVO.setValue1(ExNumeric.formatValue((BigDecimal)dischargeFactorValue.divide(new BigDecimal(lossFactorVOList.size()), 10, 4), (Integer)5));
        }
        return reportFactorVO;
    }

    private PowerNetReportTotalMapVO getCalculateReportTotalMapVO(List<CalculateReportLayoutTotalVO> totalList) {
        ArrayList<String> totalTypes = new ArrayList<String>();
        totalTypes.add("MAIN");
        totalTypes.add("META");
        totalList = totalList.stream().filter(f -> totalTypes.contains(f.getTotalType())).collect(Collectors.toList());
        log.info("totalList={}", (Object)JSON.toJSONString(totalList));
        Map<String, String> totalMap = totalList.stream().collect(Collectors.toMap(CalculateReportLayoutTotalVO::getTotalName, CalculateReportLayoutTotalVO::getTotalValueStr));
        PowerNetReportTotalMapVO totalMapVO = new PowerNetReportTotalMapVO();
        totalMapVO.setTotalValue(MapUtils.getString(totalMap, (Object)"企业二氧化碳排放总量", (String)""));
        totalMapVO.setValue1(MapUtils.getString(totalMap, (Object)"六氟化硫回收排放量", (String)""));
        totalMapVO.setValue2(MapUtils.getString(totalMap, (Object)"输配电损失排放量", (String)""));
        return totalMapVO;
    }

    private Map<String, BigDecimal> getSumBigDecimalMap(List<CalculateLayoutItemVO> calculateItemList) {
        Map<String, BigDecimal> retMap = new HashMap<String, BigDecimal>();
        if (CollectionUtils.isNotEmpty(calculateItemList)) {
            List itemValueList = calculateItemList.stream().flatMap(f -> f.getItemValueList().stream()).collect(Collectors.toList());
            List computeItemValueList = itemValueList.stream().filter(f -> this.getComputeValueTypeEnumList().contains(f.getValueType())).collect(Collectors.toList());
            retMap = DataCollectors.getSum(computeItemValueList, CalculateLayoutItemValueVO::getValueCode, m -> this.convert2BigDecimal(m.getValue()));
        }
        return retMap;
    }

    private String getItemValue(Map<String, BigDecimal> computeItemValueSumMap, String valueType, String valueCode, String value, int valueSize) {
        if (CalculateItemValueTypeEnum.CONSUMPTION.getKey().equals(valueType)) {
            return computeItemValueSumMap.get(valueCode).toString();
        }
        if (CalculateItemValueTypeEnum.FACTOR.getKey().equals(valueType)) {
            return computeItemValueSumMap.get(valueCode).divide(new BigDecimal(valueSize), 4, 4).toString();
        }
        return value;
    }

    private List<String> getComputeValueTypeEnumList() {
        return Arrays.asList(CalculateItemValueTypeEnum.CONSUMPTION.getKey(), CalculateItemValueTypeEnum.FACTOR.getKey());
    }

    public String formatValue(String value) {
        if (StringUtils.isBlank((CharSequence)value)) {
            return "";
        }
        return this.formatValue(this.convert2BigDecimal(value));
    }

    public String formatValue(BigDecimal value) {
        if (Objects.isNull(value)) {
            return "";
        }
        DecimalFormat df = new DecimalFormat("#,##0.####");
        return df.format(value);
    }

    public BigDecimal convert2BigDecimal(String value) {
        if (StringUtils.isBlank((CharSequence)value)) {
            return BigDecimal.ZERO;
        }
        return new BigDecimal(value.replace(",", ""));
    }
}

